=== debian/changelog ===
simbody (3.5.1+dfsg-1~exp1) experimental; urgency=medium

  * Use RelwithDebInfo to build
  * Update cleanup script
  * Update debian files from 3.4 -> 3.5
  * Imported Upstream version 3.5.1

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 12 Jan 2015 19:32:48 +0100
