## simbody 3.5.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -37,9 +37,9 @@
 
 SET(SIMBODY_MAJOR_VERSION 3)
 SET(SIMBODY_MINOR_VERSION 5)
-SET(SIMBODY_PATCH_VERSION 1)
-
-SET(SIMBODY_COPYRIGHT_YEARS "2005-14")
+SET(SIMBODY_PATCH_VERSION 3)
+
+SET(SIMBODY_COPYRIGHT_YEARS "2005-15")
 
 # underbar separated list of dotted authors, no spaces or commas
 SET(SIMBODY_AUTHORS "Michael.Sherman_Peter.Eastman")
