=== debian/changelog ===
simbody (3.5.3+dfsg-1ubuntu1) xenial; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Use the __linux__ macro instead of __linux.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 25 Mar 2016 02:54:48 -0700

simbody (3.5.3+dfsg-1) unstable; urgency=medium

  * Imported Upstream version 3.5.3 (Closes: #801132)
  * Add testing cloud configuration to Excluded files
  * Make copyright to follow strictly dep5

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Sun, 15 Nov 2015 23:36:46 +0100

simbody (3.5.1+dfsg-1.1ubuntu1) wily; urgency=medium

  * Use the __linux__ macro instead of __linux.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 06 Oct 2015 16:14:48 +0200

simbody (3.5.1+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload. (See #791280)

  [ Iain Lane ]
  * Rename library packages for g++5 ABI transition.

 -- Scott Kitterman <scott@kitterman.com>  Sat, 29 Aug 2015 09:44:30 -0400

simbody (3.5.1+dfsg-1) unstable; urgency=medium

  [ Frederic Bonnard ]
  * Team upload.
  * [2cdc785] Fix FTBFS on ppc64el. (Closes: #768155)

 -- Anton Gladky <gladk@debian.org>  Sun, 10 May 2015 00:01:43 +0200
