=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: simbody
 Standards-Version: 3.9.6
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
 Section: science
 Priority: extra
@@ -16,12 +17,14 @@
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/simbody.git
 Homepage: https://simtk.org/home/simbody
 
-Package: libsimbody3.5
+Package: libsimbody3.5v5
 Section: libs
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Multi-Arch: same
+Conflicts: libsimbody3.5
+Replaces: libsimbody3.5
 Description: SimTK multibody dynamics API - shared library
  Simbody is a SimTK toolset providing general multibody dynamics capability,
  that is, the ability to solve Newton's 2nd law F=ma in any set of generalized
@@ -36,7 +39,7 @@
          libxi-dev,
          libxmu-dev,
          liblapack-dev,
-	 libsimbody3.5 (= ${binary:Version}),
+	 libsimbody3.5v5 (= ${binary:Version}),
 	 ${misc:Depends}
 Multi-Arch: same
 Description: SimTK multibody dynamics API - development files
@@ -49,12 +52,14 @@
  This package contains development files (headers, shared library
  symbolic link and pkg-config file).
 
-Package: libsimbody3.5-dbg
+Package: libsimbody3.5v5-dbg
 Architecture: any
 Section: debug
-Depends: libsimbody3.5 (= ${binary:Version}),
+Depends: libsimbody3.5v5 (= ${binary:Version}),
          ${misc:Depends}
 Multi-Arch: foreign
+Conflicts: libsimbody3.5-dbg
+Replaces: libsimbody3.5-dbg
 Description: SimTK multibody dynamics API - Debugging Symbols
  Simbody is a SimTK toolset providing general multibody dynamics capability,
  that is, the ability to solve Newton's 2nd law F=ma in any set of generalized
