=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,7 @@
 	rm debian/tmp/usr/share/doc/simbody/CHANGELOG.md
 
 override_dh_strip:
-	dh_strip -a --dbg-package=libsimbody3.5-dbg
+	dh_strip -a --dbg-package=libsimbody3.5v5-dbg
 
 %:
 	dh $@ --parallel --buildsystem=cmake
