=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg// \
     https://github.com/simbody/simbody/tags .*/v?Simbody-(\d\S*)\.tar\.gz
